<?php

declare(strict_types=1);

namespace App\Service\DrinkType;

use App\Entity\DrinkType;
use App\Entity\PropertyChangeLog;
use App\Repository\PropertyChangeLogRepository;

final readonly class GetWantedHistory
{
    public function __construct(private PropertyChangeLogRepository $propertyChangeLogRepository) {}
    /** @return PropertyChangeLog[] */
    public function __invoke(DrinkType $drinkType): array
    {
        if ($drinkType->getId() === null) {
            return[];
        }

        $items =  $this->propertyChangeLogRepository->findBy([
            'entityClass' => DrinkType::class,
            'propertyName' => 'wantedStock',
            'entityId' => $drinkType->getId(),
        ]);
        $wantedStock = new PropertyChangeLog();
        $wantedStock->setNewValue((string) $drinkType->getWantedStock());
        $wantedStock->setEntityClass(DrinkType::class);
        $wantedStock->setEntityId($drinkType->getId());
        $wantedStock->setPropertyName('wantedStock');
        $items[] = $wantedStock;
        return $items;
    }
}
